/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <loop.h>
#include <loop/types.h>
#include <aio.h>
#include <stdlib.h>

int loop_add_aio(struct aio *const a)
{
    struct aio_poll *const p = malloc(sizeof *p);

    if (!p)
        return -1;

    *p = (const struct aio_poll){.aio = a};

    if (!loop_aio_head)
        loop_aio_head = p;
    else if (loop_aio_tail)
    {
        loop_aio_tail->next = p;
        p->prev = loop_aio_tail;
    }

    loop_aio_tail = p;
    return 0;
}
